# -*- encoding: utf-8 -*-
##############################################################################
#
#    Copyright (c) 2009 Luigi Grilli (luigi.grilli at gmail.com)
#                          All Rights Reserved.
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
##############################################################################


import pooler
import time
import datetime
import wizard
import netsvc
import base64
import tools
from osv import fields, osv
from tools.translate import _     
from tempfile import TemporaryFile     
from tools.misc import debug
import metel_import

_finish_form ="""<?xml version="1.0"?>
<form string="Metel pricelist import">
    <separator string="Metel pricelist import report" colspan="4" />
    <field name="uo_message"/>
</form>"""

_ask_form ="""<?xml version="1.0"?>
<form string="Metel pricelist import">
    <label string="Please select metel pricelist file to import." colspan="4"/>
    <field name="metel_file"/>
</form>"""

_ask_fields = {
    'metel_file': {'string': 'Metel pricelist file', 'type': 'binary', 'required': True},
}

_finish_fields = {
    'uo_message': {'string':'Status', 'readonly': True, 'type':'text'},
}

class metel_import_pricelist(wizard.interface):
    def ImportPriceList(self, cr, uid, data, context):
        '''Import the pricelist from a Metel file, creating products where needed
        
        Returns:
          uo_message: Messagge for the user
        '''
        
        
        #initialization
        metel = metel_import.MetelImport()
        execute = metel.Init(cr, uid, base64.decodestring(data['form']['metel_file']))
        
        if execute == 1:
            metel.start()
            uo_message = _("Import operation in progress")
        elif execute == -1:
            uo_message = _("Error: could not find a partner with this metel code: %s") % metel.prod
        elif execute == -2:
            uo_message = _("Error: no import category defined for the partner.")
        
        return {'uo_message': uo_message}

    states = {
        'init': {
            'actions': [],
            'result': {
                'type': 'form',
                'arch': _ask_form,
                'fields': _ask_fields,
                'state': [
                    ('end', 'Cancel', 'gtk-cancel'),
                    ('import', 'Import pricelist', 'gtk-ok', True)
                ]
            }
        },
        'import': {
            'actions': [ImportPriceList],
            'result': {
                'type': 'form',
                'arch': _finish_form,
                'fields': _finish_fields,
                'state': [('end','End')]
            }
        },
    }
metel_import_pricelist("metel.pricelist")

# vim:expandtab:smartindent:tabstop=4:softtabstop=4:shiftwidth=4:

